import { Component, Input, NgModule, ViewChild } from "@angular/core";
import { NG_VALUE_ACCESSOR } from "@angular/forms";
var noop = function () { };
var ɵ0 = noop;
var nextId = 0;
var IgxCheckboxComponent = /** @class */ (function () {
    function IgxCheckboxComponent() {
        this.focused = false;
        this.id = "igx-checkbox-" + nextId++;
        this.disabled = false;
        this.tabindex = null;
        this.checked = false;
        this._onTouchedCallback = noop;
        this._onChangeCallback = noop;
    }
    IgxCheckboxComponent.prototype.onChange = function (event) {
        if (this.disabled) {
            return;
        }
        this.checked = !this.checked;
        this._onChangeCallback(this.checked);
    };
    IgxCheckboxComponent.prototype.onFocus = function (event) {
        this.focused = true;
    };
    IgxCheckboxComponent.prototype.onBlur = function (event) {
        this.focused = false;
        this._onTouchedCallback();
    };
    IgxCheckboxComponent.prototype.writeValue = function (value) {
        if (this.disabled) {
            return;
        }
        this._value = value;
        this.checked = !!this._value;
    };
    IgxCheckboxComponent.prototype.registerOnChange = function (fn) { this._onChangeCallback = fn; };
    IgxCheckboxComponent.prototype.registerOnTouched = function (fn) { this._onTouchedCallback = fn; };
    IgxCheckboxComponent.decorators = [
        { type: Component, args: [{
                    providers: [{ provide: NG_VALUE_ACCESSOR, useExisting: IgxCheckboxComponent, multi: true }],
                    selector: "igx-checkbox",
                    template: "<div class=\"igx-control\">     <input class=\"igx-control__cbx\" #checkbox type=\"checkbox\"         [attr.id]=\"id\"         [attr.name]=\"name\"         [attr.value]=\"value\"         [attr.tabindex]=\"tabindex\"         [attr.disabled]=\"disabled ? true : null\"         [checked]=\"checked\"         [attr.aria-checked]=\"checked\"         (change)=\"onChange($event)\"         (focus)=\"onFocus($event)\"         (blur)=\"onBlur($event)\">     <label class=\"igx-control__label\" [attr.for]=\"id\">         <svg class=\"tick\" xmlns=\"http://www.w3.org/2000/svg\" viewBox=\"0 0 22 22\">             <g fill=\"none\" fill-rule=\"evenodd\">                 <path class=\"tick__mark\" d=\"M2 10.8l5 5L18.8 4\"/>             </g>         </svg>         <ng-content></ng-content>     </label> </div>"
                },] },
    ];
    /** @nocollapse */
    IgxCheckboxComponent.ctorParameters = function () { return []; };
    IgxCheckboxComponent.propDecorators = {
        "value": [{ type: Input },],
        "id": [{ type: Input },],
        "name": [{ type: Input },],
        "disabled": [{ type: Input },],
        "tabindex": [{ type: Input },],
        "checked": [{ type: Input },],
        "nativeCheckbox": [{ type: ViewChild, args: ["checkbox",] },],
    };
    return IgxCheckboxComponent;
}());
export { IgxCheckboxComponent };
var IgxCheckboxModule = /** @class */ (function () {
    function IgxCheckboxModule() {
    }
    IgxCheckboxModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [IgxCheckboxComponent],
                    exports: [IgxCheckboxComponent]
                },] },
    ];
    /** @nocollapse */
    IgxCheckboxModule.ctorParameters = function () { return []; };
    return IgxCheckboxModule;
}());
export { IgxCheckboxModule };
export { ɵ0 };
//# sourceMappingURL=checkbox.component.js.map