import { AfterContentInit, AfterViewInit, ChangeDetectorRef, ComponentFactoryResolver, ElementRef, EventEmitter, OnInit, QueryList, TemplateRef, ViewContainerRef } from "@angular/core";
import { DataType } from "../data-operations/data-util";
import { FilteringLogic, IFilteringExpression } from "../data-operations/filtering-expression.interface";
import { ISortingExpression, SortingDirection } from "../data-operations/sorting-expression.interface";
import { IgxForOfDirective } from "../directives/for-of/for_of.directive";
import { IgxGridAPIService } from "./api.service";
import { IgxGridCellComponent } from "./cell.component";
import { IgxColumnComponent } from "./column.component";
import { IgxGridRowComponent } from "./row.component";
export declare class IgxGridComponent implements OnInit, AfterContentInit, AfterViewInit {
    private gridAPI;
    private elementRef;
    private document;
    cdr: ChangeDetectorRef;
    private resolver;
    private viewRef;
    data: any[];
    autoGenerate: boolean;
    id: string;
    filteringLogic: FilteringLogic;
    filteringExpressions: any[];
    paging: boolean;
    page: number;
    perPage: number;
    paginationTemplate: TemplateRef<any>;
    height: any;
    width: any;
    evenRowCSS: string;
    oddRowCSS: string;
    onSelection: EventEmitter<any>;
    onEditDone: EventEmitter<any>;
    onColumnInit: EventEmitter<any>;
    onSortingDone: EventEmitter<any>;
    onFilteringDone: EventEmitter<any>;
    onPagingDone: EventEmitter<any>;
    onRowAdded: EventEmitter<any>;
    onRowDeleted: EventEmitter<any>;
    columnList: QueryList<IgxColumnComponent>;
    rowList: QueryList<IgxGridRowComponent>;
    parentVirtDir: IgxForOfDirective<any>;
    headerContainer: IgxForOfDirective<any>;
    theadRow: ElementRef;
    tfoot: ElementRef;
    tabindex: number;
    hostClass: string;
    hostRole: string;
    readonly pipeTrigger: number;
    sortingExpressions: any[];
    pagingState: any;
    calcWidth: number;
    calcHeight: number;
    cellInEditMode: IgxGridCellComponent;
    protected _perPage: number;
    protected _page: number;
    protected _paging: boolean;
    protected _pipeTrigger: number;
    protected _columns: any[];
    protected _filteringLogic: FilteringLogic;
    protected _filteringExpressions: any[];
    protected _sortingExpressions: any[];
    constructor(gridAPI: IgxGridAPIService, elementRef: ElementRef, document: any, cdr: ChangeDetectorRef, resolver: ComponentFactoryResolver, viewRef: ViewContainerRef);
    ngOnInit(): void;
    ngAfterContentInit(): void;
    ngAfterViewInit(): void;
    readonly nativeElement: any;
    readonly columns: IgxColumnComponent[];
    getColumnByName(name: string): IgxColumnComponent;
    readonly visibleColumns: IgxColumnComponent[];
    getCellByColumn(rowIndex: number, columnField: string): IgxGridCellComponent;
    readonly totalPages: number;
    readonly totalRecords: number;
    readonly isFirstPage: boolean;
    readonly isLastPage: boolean;
    nextPage(): void;
    previousPage(): void;
    paginate(val: number): void;
    markForCheck(): void;
    addRow(data: any): void;
    deleteRow(rowIndex: number): void;
    updateCell(value: any, rowIndex: number, column: string): void;
    updateRow(value: any, rowIndex: number): void;
    sort(...rest: any[]): void;
    filter(...rest: any[]): void;
    filterGlobal(value: any, condition?: any, ignoreCase?: any): void;
    clearFilter(name?: string): void;
    clearSort(name?: string): void;
    readonly hasSortableColumns: boolean;
    readonly hasEditableColumns: boolean;
    readonly hasFilterableColumns: boolean;
    readonly selectedCells: IgxGridCellComponent[] | any[];
    protected _sort(name: string, direction?: SortingDirection, ignoreCase?: boolean): void;
    protected _sortMultiple(expressions: ISortingExpression[]): void;
    protected _filter(name: string, value: any, condition?: any, ignoreCase?: any): void;
    protected _filterMultiple(expressions: IFilteringExpression[]): void;
    protected resolveDataTypes(rec: any): DataType;
    protected autogenerateColumns(): void;
}
