import { CommonModule } from "@angular/common";
import { Component, EventEmitter, Input, NgModule, Output } from "@angular/core";
import { IgxButtonModule } from "../directives/button/button.directive";
import { IgxIconModule } from "../icon/icon.component";
var IgxNavbarComponent = /** @class */ (function () {
    function IgxNavbarComponent() {
        /**
             * The IgxNavbar action button visual state state
             * @type {boolean}
             */
        this.isActionButtonVisible = false;
        /**
             * The event that will be thrown when the action is executed,
             * provides reference to the IgxNavbar component as argument
             * @type {EventEmitter}
             */
        this.onAction = new EventEmitter();
        this.titleId = "igx-navbar-" + IgxNavbarComponent.NEXT_ID++;
    }
    IgxNavbarComponent.prototype._triggerAction = function () {
        this.onAction.emit(this);
    };
    IgxNavbarComponent.NEXT_ID = 1;
    IgxNavbarComponent.decorators = [
        { type: Component, args: [{
                    selector: "igx-navbar",
                    template: "<nav class=\"igx-navbar\" role=\"navigation\" [attr.aria-labelledby]=\"titleId\">     <div class=\"igx-navbar__left\">         <span class=\"igx-navbar__left-btn\" *ngIf=\"!isActionButtonVisible\">             <button igxButton=\"navbar\" (click)=\"_triggerAction()\">                 <igx-icon fontSet=\"material\" [name]=\"actionButtonIcon\"></igx-icon>             </button>         </span>         <span>             <h1 class=\"igx-navbar__title\" [attr.id]=\"titleId\">{{ title }}</h1>         </span>     </div>     <div class=\"igx-navbar__right\">         <ng-content></ng-content>     </div> </nav>"
                },] },
    ];
    /** @nocollapse */
    IgxNavbarComponent.ctorParameters = function () { return []; };
    IgxNavbarComponent.propDecorators = {
        "isActionButtonVisible": [{ type: Input },],
        "actionButtonIcon": [{ type: Input },],
        "title": [{ type: Input },],
        "onAction": [{ type: Output },],
        "titleId": [{ type: Input },],
    };
    return IgxNavbarComponent;
}());
export { IgxNavbarComponent };
var IgxNavbarModule = /** @class */ (function () {
    function IgxNavbarModule() {
    }
    IgxNavbarModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [IgxNavbarComponent],
                    exports: [IgxNavbarComponent],
                    imports: [IgxButtonModule, IgxIconModule, CommonModule]
                },] },
    ];
    /** @nocollapse */
    IgxNavbarModule.ctorParameters = function () { return []; };
    return IgxNavbarModule;
}());
export { IgxNavbarModule };
//# sourceMappingURL=navbar.component.js.map